/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumTemplatestyle;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TInputExportRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputExport extends TableImpl<TInputExportRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_export</code>
     */
    public static final TInputExport T_INPUT_EXPORT = new TInputExport();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputExportRecord> getRecordType() {
        return TInputExportRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_export.lastchange</code>.
     */
    public final TableField<TInputExportRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_export.pk</code>.
     */
    public final TableField<TInputExportRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_export.fk_element</code>. foreign key
     * to key_element of referenced form
     */
    public final TableField<TInputExportRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of referenced form");

    /**
     * The column <code>common_dd.t_input_export.template_code</code>. code of
     * template
     */
    public final TableField<TInputExportRecord, String> TEMPLATE_CODE = createField(DSL.name("template_code"), SQLDataType.CLOB.nullable(false), this, "code of template");

    /**
     * The column <code>common_dd.t_input_export.template_style</code>. style of
     * template (plain, latex)
     */
    public final TableField<TInputExportRecord, EnumTemplatestyle> TEMPLATE_STYLE = createField(DSL.name("template_style"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumTemplatestyle.class), this, "style of template (plain, latex)");

    /**
     * The column <code>common_dd.t_input_export.template_name</code>. name of
     * read template; can contain template variables
     */
    public final TableField<TInputExportRecord, String> TEMPLATE_NAME = createField(DSL.name("template_name"), SQLDataType.CLOB.nullable(false), this, "name of read template; can contain template variables");

    /**
     * The column <code>common_dd.t_input_export.template_class</code>.
     * deprecated; use template_style instead; class of template (0 - plain, 1 -
     * latex)
     */
    public final TableField<TInputExportRecord, Integer> TEMPLATE_CLASS = createField(DSL.name("template_class"), SQLDataType.INTEGER.nullable(false), this, "deprecated; use template_style instead; class of template (0 - plain, 1 - latex)");

    private TInputExport(Name alias, Table<TInputExportRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputExport(Name alias, Table<TInputExportRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_export</code> table reference
     */
    public TInputExport(String alias) {
        this(DSL.name(alias), T_INPUT_EXPORT);
    }

    /**
     * Create an aliased <code>common_dd.t_input_export</code> table reference
     */
    public TInputExport(Name alias) {
        this(alias, T_INPUT_EXPORT);
    }

    /**
     * Create a <code>common_dd.t_input_export</code> table reference
     */
    public TInputExport() {
        this(DSL.name("t_input_export"), null);
    }

    public <O extends Record> TInputExport(Table<O> path, ForeignKey<O, TInputExportRecord> childPath, InverseForeignKey<O, TInputExportRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_EXPORT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputExportPath extends TInputExport implements Path<TInputExportRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputExportPath(Table<O> path, ForeignKey<O, TInputExportRecord> childPath, InverseForeignKey<O, TInputExportRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputExportPath(Name alias, Table<TInputExportRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputExportPath as(String alias) {
            return new TInputExportPath(DSL.name(alias), this);
        }

        @Override
        public TInputExportPath as(Name alias) {
            return new TInputExportPath(alias, this);
        }

        @Override
        public TInputExportPath as(Table<?> alias) {
            return new TInputExportPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputExportRecord, Integer> getIdentity() {
        return (Identity<TInputExportRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputExportRecord> getPrimaryKey() {
        return Keys.PK_INPUT_EXPORT;
    }

    @Override
    public List<UniqueKey<TInputExportRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_EXPORT);
    }

    @Override
    public List<ForeignKey<TInputExportRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_EXPORT__FK_INPUT_EXPORT_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_EXPORT__FK_INPUT_EXPORT_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TInputExport as(String alias) {
        return new TInputExport(DSL.name(alias), this);
    }

    @Override
    public TInputExport as(Name alias) {
        return new TInputExport(alias, this);
    }

    @Override
    public TInputExport as(Table<?> alias) {
        return new TInputExport(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputExport rename(String name) {
        return new TInputExport(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputExport rename(Name name) {
        return new TInputExport(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputExport rename(Table<?> name) {
        return new TInputExport(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport where(Condition condition) {
        return new TInputExport(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputExport where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputExport where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputExport where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputExport where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputExport whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
